/*
                    MM   MM    OOOOO    5555555
                    M M M M   O     O   5
                    M  M  M   O     O   555555
                    M     M   O     O         5
                    M     M   O     O         5
                    M     M    OOOOO    555555

                             EMULATEUR

                         Par Edouard FORLER
                    (edouard.forler@di.epfl.ch)
                          Par Sylvain HUET
                    (huet@poly.polytechnique.fr)
                               1997

  enterkey.c : definition des touches 

*/

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>

#define nbkey 69

int suspend=0,buffer=0,newk=0;

char    cods[]=
"N EFF J H U Y 7 6 , INS K G I T 8 5 . RETOUR_COIN L F O R 9 4 \
@ DROITE M D P E 0 3 ESPACE BAS B S / Z - 2 X GAUCHE V Q * A + \
1 W HAUT C RAZ ENTREE CNT ACC STOP SHIFT BASIC \
joystick0_haut gauche bas droite bouton \
joystick1_haut gauche bas droite bouton stop_emulateur ";

char    *pnt;

int             black,white;
char            *nomstat=NULL;
Display         *display;
int             screen;
Colormap        cmap;
Visual          *visual;
Window          root,win;
GC              gc;


void iniscreen()
{
  int   i,j,n;
  XGCValues xgc;
  display=XOpenDisplay(nomstat);
  screen=DefaultScreen(display);
  visual=DefaultVisual(display,screen);
  cmap=DefaultColormap(display,screen);
  root=RootWindow(display,screen);
  black=BlackPixel(display,screen);
  white=WhitePixel(display,screen);
  gc=DefaultGC(display,screen);
  
  win=XCreateSimpleWindow(display, root,0,0,640,400,1,white,black);
  XSetStandardProperties(display, win, "MO5-clavier","MO5-clavier",0,
                         NULL,0,NULL);
  XSetWindowColormap(display,win,cmap);
  XSelectInput(display,win,KeyPressMask);
  XMapWindow(display,win);
  
}

void printkey()
{
  char c;
  do
  {
    c=*(pnt++);
    putchar(c);
  }
  while(c!=32);
  fflush(stdout);
}

void main()
{
  XEvent  ev;
  int     j;
  int     key[256];
  char    filename[256];
  FILE    *fl;

  iniscreen();
  printf("Enterkey MO5, version 1.4, par Edouard FORLER, portions par Sylvain HUET\n");

  printf("Nom du fichier a creer: ");
  scanf("%s",&filename);

  if (fl=fopen(filename,"r"))
  {
    char rep[5];

    printf("Le fichier %s existe deja! Ecraser (o/n) ?",filename);
    scanf("%s",&rep); 
    if ((rep[0]!='o') && (rep[0]!='O')) exit(1);
    fclose(fl);
  }

  printf("Frappez la touche du clavier PC correspondant a:");

  pnt=cods;
  for(j=0;j<nbkey;j++)
  {
    printf("\ntouche ");
    printkey();
       
    XNextEvent(display,&ev);
    switch(ev.type) 
    {
      case KeyPress: key[j]=ev.xkey.keycode&255;
                     break;
      default: break;  
    }

  }

  if (fl=fopen(filename,"w"))
  {
    for(j=0;j<nbkey;j++)
      fprintf(fl,"%d\n",key[j]);
    fclose(fl);
  }
}

