/*
                    MM   MM    OOOOO    5555555
                    M M M M   O     O   5
                    M  M  M   O     O   555555
                    M     M   O     O         5
                    M     M   O     O         5
                    M     M    OOOOO    555555

                             EMULATEUR

                         Par Edouard FORLER
                    (edouard.forler@di.epfl.ch)
                          Par Sylvain HUET
                    (huet@poly.polytechnique.fr)
                               1997

  intrpt.c : routines d'interruption pour la gestion du clavier
             et des IRQs

*/

#include <sys/time.h>
#include <signal.h>

#include "intrpt.h"
#include "video.h"
#include "monitor.h"

int keycode[nbtouche];
int keyprsd[nbtouche];

int stopkey;
int retvideo;

int suspend=0,do_irq=0;
char cpt1=0;

FILE *fl2;

struct itimerval fifty;

void inikey(char *name) 
{
  int i,key;

  if (fl2=fopen(name,"r"))
  {
    for(i=0;i<nbtouche;i++)
    {
      fscanf(fl2,"%d",&key);
      keycode[i]=key;
      keyprsd[i]=1;
    }
    fclose(fl2);
  }
  else
  {
    printf("Erreur configuration clavier (fichier %s inexistant?)\n",name);
    exit(0);
  }

  stopkey=keycode[nbtouche-1];

  /* manettes de jeu */
  buf[0xa7cc]=0;
  buf[0xa7cd]=0;
  buf[0xa7ce]=0;
  buf[0xa7cf]=0;

  buf[0xa7c1]=prb1=128;
}

void new_timer(int a)
{
    retvideo=128;
    buf[0xa7c3]|=128;
    do_irq=1;
}

int whatkey(int key)
{
  int i;

    for (i=0;i<nbtouche-1;i++)
      if (keycode[i]==key) return i;

  return 0xffff;
}

/*void interrupt new_kbd()
{
  int i=suspend+inp(0x60),a;
  
  if ((i&0xff)==0xe0) suspend=0x8000;
  else
  {
    if ((i!=0x802a)&&(i!=0x80aa))
    {
      if (i&128)
      {
        if ((a=whatkey(i&0xff7f))!=0xffff) keyprsd[a]=1;
      }
      else
        if ((a=whatkey(i))!=0xffff) keyprsd[a]=0;
    }
    suspend=0;
  }
  outp(0x20,0x20);
}*/

void startintr()
{
  fifty.it_interval.tv_sec=0;
  fifty.it_interval.tv_usec=20000;
  fifty.it_value.tv_sec=0;
  fifty.it_value.tv_usec=20000;
 
  signal(SIGALRM,new_timer); 
    setitimer(ITIMER_REAL,&fifty,NULL);
}

void stopintr()
{
  int i;
    
  fifty.it_interval.tv_sec=0;
  fifty.it_interval.tv_usec=0;
  fifty.it_value.tv_sec=0;
  fifty.it_value.tv_usec=0;

   signal(SIGALRM,NULL);
      setitimer(ITIMER_REAL,&fifty,NULL);

  for(i=0;i<nbtouche;i++) keyprsd[i]=1;
}













