/*
                    MM   MM    OOOOO    5555555
                    M M M M   O     O   5
                    M  M  M   O     O   555555
                    M     M   O     O         5
                    M     M   O     O         5
                    M     M    OOOOO    555555

                             EMULATEUR

                         Par Edouard FORLER
                    (edouard.forler@di.epfl.ch)
                          Par Sylvain HUET
                    (huet@poly.polytechnique.fr)
                               1997

  video.c : routines video de l'emulateur (+gestion memoire)

*/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>

#include "monitor.h"
#include "emumo5.h"
#include "intrpt.h"
#include "sb.h"

#define v1 48
#define v2 63

int		black,white;
char		*nomstat=NULL;
Display		*display;
int		screen;
Colormap	cmap;
Visual		*visual;
Window		root,win;
GC		gc,mygc[256];
short		imac[400],codedb[256];
XImage		*ima;
XColor		tCol,tCol_exact;
static char	*nom[16]=
{"black","red","green","yellow","blue","magenta","cyan","white",
 "gray","pink","pale green","light yellow","light slate blue","violet"
 ,"light cyan","orange"};

int		col[16];


char		modif[1040];
int		conv[8192];

FILE    *fk7;
FILE    *fqd;
int     crayx,crayy;
int     lasttour;

int     nbwait;
int     nb45,nb63;

int     gainit;

int     pra1,prb1,cra1,crb1;

int     pain2,paout2,crain2;
int     pbin2,pbout2,crbin2;

int     bank = 0xb000;

void inicray()
{
  crayx=-1;
}

void newcass(char *c)
{
  if (fk7) fclose(fk7);
  if ((fk7=fopen(c,"rb+"))==NULL)
  {
    if ((fk7=fopen(c,"wb+"))!=NULL) printf("CASSETTE VIERGE NEUVE\n");
  }
  if (fk7==NULL) if (fk7=fopen(c,"rb")) printf("LECTURE SEULE\n");
  if (fk7==NULL) printf("impossible\n");
  else
    printf("cassette %s\n",c);
}

void newqd(char *c)
{
  if (fqd) fclose(fqd);
  if ((fqd=fopen(c,"rb+"))==NULL)
  {
    /* Fabrication d'une nouvelle disquette formatee! */
    // ici copie dsk formate 
    //fqd=fopen(c,"rb+");
  }
  if (fqd==NULL) if (fqd=fopen(c,"rb")) printf("LECTURE SEULE\n");
  if (fqd==NULL) printf("impossible\n");
  else
    printf("quick disk %s\n",c);
}

void avanck7(long k)
{
  if (fk7==NULL)
    printf("impossible\n");
  else
  {
    if (k>=0) fseek(fk7,k,0);
    printhx(ftell(fk7),4);
    printf(" : position courante\n");
  }
}

void inik7()
{
  fk7=NULL;
}

void iniqd()
{
  fqd=NULL;
}

void putk7(long i,FILE *f)
{
  int hp,b,j,k;

  if (!fastk7)
  {
    hp=0; //inp(0x61)&2;


  b=128;
  while(b)
    {
      if (b&i) // un 1
      {
        if (hp==255) hp=0; else hp=255;
        if (snd) speakerout(hp);
        for(j=0;j<7;j++)  
          for(k=0;k<nb63;k++);
        if (hp==255) hp=0; else hp=255;
        if (snd) speakerout(hp);
        for(j=0;j<7;j++)  
          for(k=0;k<nb63;k++);
      }
      else // un 0
      {
        if (hp==255) hp=0; else hp=255;
        if (snd) speakerout(hp);
        for(j=0;j<14;j++)  
          for(k=0;k<nb63;k++);
      }
      b>>=1;
    }
  }
  fputc(i,fk7);
}

int getk7(FILE *f)
{
  int i,b,j,k,hp;

  hp=0; //inp(0x61)&2;

  i=fgetc(f);
  if((i!=EOF)&&(!fastk7)) // bruit k7
  {
    b=128;
    while(b)
    {
      if (b&i) // un 1
      {
        if (hp==255) hp=0; else hp=255;
        if (snd) speakerout(hp);
        for(j=0;j<7;j++)
          for(k=0;k<nb63;k++);
        if (hp==255) hp=0; else hp=255;
        if (snd) speakerout(hp);
        for(j=0;j<7;j++)  
          for(k=0;k<nb63;k++);
      }
      else // un 0
      {
        if (hp==255) hp=0; else hp=255;
        if (snd) speakerout(hp);
        for(j=0;j<14;j++)  
          for(k=0;k<nb63;k++);
      }
      b>>=1;
    }
  }
  return i;
}
        
void iniscreen(char *name)
{
  int	i,j,k,l,n;
  XGCValues xgc;
  display=XOpenDisplay(nomstat);
  screen=DefaultScreen(display);
  visual=DefaultVisual(display,screen);
  cmap=DefaultColormap(display,screen);
  root=RootWindow(display,screen);
  black=BlackPixel(display,screen);
  white=WhitePixel(display,screen);
  gc=DefaultGC(display,screen);
  

      for (i=0;i<16;i++) 
        {
          XAllocNamedColor(display,cmap,nom[i],&tCol,&tCol_exact);
          col[i]=tCol.pixel;
        }
      
      for (i=0;i<16;i++)
        for (j=0;j<16;j++)
	  {
             mygc[i*16+j]=XCreateGC(display,root,0,&xgc);
             XSetForeground(display,mygc[i*16+j],col[i]);
             XSetBackground(display,mygc[i*16+j],col[j]);
          }

      
  win=XCreateSimpleWindow(display, root,0,0,680,440,1,white,black);
  XSetStandardProperties(display, win, "XEmul5, l'emulateur MO5 pour Linux","XEmul5, l'emulateur MO5 pour Linux",0,
                         NULL,0,NULL);
  XSetWindowColormap(display,win,cmap);
  XSelectInput(display,win,ExposureMask|ButtonPressMask|ButtonReleaseMask
               |Button2MotionMask|KeyPressMask|KeyReleaseMask);
  XMapWindow(display,win);
  
  ima=XCreateImage(display,visual,
                   1,XYBitmap,0,(char *) imac,16,16*25,16,2);
  for(i=0;i<256;i++)
    {
      for (j=7,n=i;j>=0;j--,n>>=1)
        {
          XPutPixel(ima,j*2,0,n&1);
          XPutPixel(ima,j*2+1,0,n&1);
        }
      codedb[i]=imac[0];
    }
  XFlush(display);
  
  for(i=0;i<8192;i++) conv[i]=(i%40)*25+(i/320);
  inikey(name);
  inicray();
  inik7();
  lasttour=15;

}

void refreshv()
{
  char	*fr;
  char	*fd;
  char	*p;
  char	*q;
  int	x,y;
  int	j;
  int	cl;
  char	*tes;

  
  fr=&buf[0x0000];
  fd=&buf[0x10000];
  tes=modif;
  for(x=0;x<640;x+=16)
    {
      j=0;
      cl=*fd;
      p=fr;
      q=fd;
      for(y=0;y<400;y+=2)
        {
          if (!(y&15))
            {
              if (*tes)	*(tes++)=0;
              else	
                {
                if (y-j) XPutImage(display,win
                                   ,mygc[(cl&255)],ima,0,0,x+20,j+20,16,y-j);
                y+=14;
                p+=320;
                q+=320;
                cl=*q;
                j=y+2;
                tes++;
                continue;
              }	
            }
          if ((*q)!=cl)
            {
              XPutImage(display,win,mygc[(cl&255)]
                        ,ima,0,0,x+20,j+20,16,y-j);
              j=y;
              cl=*q;
            }
          imac[y-j]=imac[y+1-j]=codedb[((*p)&255)];
          p+=40;
          q+=40;
          
        }
      if(y-j) XPutImage(display,win
                        ,mygc[(cl&255)],ima,0,0,x+20,j+20,16,y-j);
      fr+=1;
      fd+=1;
    }

  if (lasttour!=(buf[0xa7c0]&0x1e))
    {
      lasttour=(buf[0xa7c0]&0x1e);
      cl=(lasttour)<<3;
      XFillRectangle(display,win,mygc[cl],0,0,680,20);
      XFillRectangle(display,win,mygc[cl],0,20,20,400);
      XFillRectangle(display,win,mygc[cl],660,20,20,400);
      XFillRectangle(display,win,mygc[cl],0,420,680,20);
    }
  XFlush(display);
}

void refreshsc()
{
  int	i;
  
  for(i=0;i<1000;i++) modif[i]=1;
  lasttour=15;
  refreshv();
}


void cleanmemory()
{
  int i;
  for (i=0;i<endmem;i++) /*if ((i%256)<128)*/ buf[i]=0; /*else buf[i]=255;*/
  for (i=0x10000;i<leng;i++) /*if ((i%256)<128)*/ buf[i]=0; /*else buf[i]=255;*/
}

long loads(long k) 
{
  if (k==0xa7e7) /* lightpen: OK */
  {
    int a = (0x41+(retvideo))&0xc1; // retour vertical
    retvideo=0;
    return a;
  }

/*  if ((k&0xfff0)==0xa7d0)
  {
    quitf=0;
  }*/

  if ((k&0xffc0)==0xa7C0) 
  {
    /* PIA 6821 systeme */
    /* lecture clavier */
    if (k==0xa7c1)
    {
      if (!keyprsd[(prb1>>1)&63]) prb1&=127; else prb1|=128;
      buf[k]=prb1;
      return prb1;
    }
    if (k==0xa7c0)
    {
      if (fk7!=NULL) pra1|=0x80; else pra1&=0x7f;
      buf[k]=pra1;
      return pra1;
    }

    if ((k&0xfffc)==0xa7cc) /* PIA jeux 6821: OK */
    {
      /* PRA1 */
      /* a7ce bit 3 = ?? test presence joy? */
      if (k==0xa7cc)
      {
        int dummy1=0x0f,dummy2=0x0f;

        if (!keyprsd[61]) dummy1&=7;
        if (!keyprsd[60]) dummy1&=13;
        if (!keyprsd[59]) dummy1&=11;
        if (!keyprsd[58]) dummy1&=14;
        if (dummy1<5) dummy1=0x0f;

        if (!keyprsd[66]) dummy2&=7;
        if (!keyprsd[65]) dummy2&=13;
        if (!keyprsd[64]) dummy2&=11;
        if (!keyprsd[63]) dummy2&=14;
        if (dummy2<5) dummy2=0x0f;

        return dummy1+(dummy2<<4);
      }

      /* PRB1 */
      if (k==0xa7cd)
        return (buf[0xa7cd]&63)+(keyprsd[67]<<7)+(keyprsd[62]<<6);

      /* CRA1 */
      if (k==0xa7ce) return (keyprsd[62]<<7);

      /* CRB1 */
      if (k==0xa7cf) return (keyprsd[67]<<7);
    }
    return buf[k]&255;
  }

  if ((k>0xafff) && (k<0xf000))
  /* extension 64k ram */
  {
    return buf[k-0xb000+bank]&255;
  }

  /* VIDEO: banques, OK */
  if (k<0x2000)
  {
    if (!(buf[0xa7c0]&1)) k+=0x10000;
    return buf[k]&255;
  }
  return buf[k]&255;
}

long loadl(long k) 
{
  int val;

  if ((k&0xff00)==0xa700)
  { /* gestion des io, OK */
    return ((loads(k)<<8)+(loads(k+1)&255))&0xffff;
  }

  /* VIDEO: banques, OK */

  if (k<0x2000) 
  {
    if (!(buf[0xa7c0]&1)) k+=0x10000;

    val=buf[k+1];
    if ((k&0xffff)==0x1fff) val=buf[0x2000]; 

    return ((buf[k]&255)<<8)+(val&255);
  }

  if (k==0xafff)
  /* frontiere extension 64k ram */
    return ((buf[0xafff]&255<<8)+(buf[k-0xafff+bank]))&0xffff;

  if (k==0xefff)
  /* frontiere extension 64k ram */
    return ((buf[k-0xb000+bank]&255<<8)+(buf[0xf000]))&0xffff;

  if ( (k>0xafff)&&(k<0xefff))
    return ((loads(k)<<8)+(loads(k+1)&255))&0xffff;

  if (k==0xffff) return ((buf[0xffff]&255)<<8)+(buf[0]&255);
  return ((buf[k]&255)<<8)+(buf[k+1]&255);
}


int stocs(long k,long val) 
{
  if (k<0x2000) /* video + ROM */ 
  {
    modif[conv[k]]=1;
    if (!(buf[0xa7c0]&1)) k+=0x10000; /* banque video */
    buf[k]=val;
    //affcur(k);
    return 0;
  }
  if (k>endmem)
  {
    if ((k>0xafff) && (k<0xf000))
    /* extension 64k ram */
    {
      if ((bank!=0xb000)&&(buf[0xa7cb]&8))
        buf[k-0xb000+bank]=val&255;
    }

    if (k==0xa7cb)
    /* controle extension ram 64k */
    {
      buf[k]=val&15;
      if ((buf[k]&4)==4)
        bank=(0x12000+16384*(val&3))&0xfffff;
      else
        bank=0xb000;
     
    }
/*    if ((k&0xfff0)==0xa7d0)
    {
      quitf=0;
    }*/
    
    if ((k&0xffc0)==0xa7C0) /* PIA systeme */
    {
      if (k==0xa7c0)
      {
        pra1=(pra1&0xa0)|(val&0x5f);
        buf[k]=pra1;
        //settour();
        return 0;
      } else
        if (k==0xa7c1)
        {
          prb1=(prb1&0x80)|(val&0x7f);
          buf[k]=prb1;
          if (snd) speakerout((val&1)*255);
          return 0;
        } else
          if (k==0xa7c2)
          {
            cra1=(cra1&0x80)|(val&0x7f);
            buf[k]=cra1;
            return 0;
          } else
            if (k==0xa7c3)
            {
              crb1=(crb1&0x80)|(val&0x7f);
              buf[k]=crb1;
              return 0;
            }

      if ((k==0xa7cc)&&(buf[0xa7ce]&4)) /* pia jeux, ok */
      {
        paout2=val;
        buf[k]=paout2;
        return 0;
      }
      if ((k==0xa7cd)&&(buf[0xa7cf]&4))
      {
        pbout2=val;
        buf[k]=pbout2;
        if (dacon) dacout((val&63)<<2); 
        return 0;
      }

      if (k==0xa7c0)
      { val=(buf[k] & 0xa0)|val;
        buf[k]=val;
        return 0;
      }

    }
    return 0;
  }

  if (k>0x1fff) buf[k]=val;
  return 0;
}

int stocl(long k,long val) 
{
  if (k<0x2000)
  {
    modif[conv[k]]=1;
    modif[conv[k+1]]=1;
    if (!(buf[0xa7c0]&1)) k+=0x10000;
    if ((k&0xffff)!=0x1fff) buf[k+1]=val; else buf[0x2000]=val;
    val>>=8;
    buf[k]=val;
    //affcur(k);
    //affcur(k+1);
    return 0;
  }
  
  if (k>endmem)
  {
    if (k==0xafff)
    /* extension ram 64k, frontiere */
    {
      stocs(k+1,val&255);
      return 0;
    }

    if (k==0xefff)
    {
      stocs(k,(val>>8)&255);
      return 0;
    }

    if ((k>0xafff)&&(k<0xefff))
    {
      stocs(k,(val>>8)&255);
      stocs(k+1,val&255);
      return 0;
    }

    if ((k&0xffc0)==0xa7C0)
    { /* gestion des io */
      stocs(k,val>>8);
      stocs(k+1,val&255);
    }
    return 0;
  }

  if ((k>0x1ffe) && (k<endmem)) buf[k+1]=val;
  val>>=8;
  if ((k>0x1fff) && (k<=endmem)) buf[k]=val;
  return 0;
}



long compt;
int  quitf;

int bouclex() 
{
  XEvent ev;
  int key;
  int i,j,k;
  int lx,ly;
  int mynb;
  int ninst,dostop;

  j=0;
  compt=0;
  quitf=1;

  pain2=paout2=crain2=255;
  pbin2=pbout2=crbin2=255;

  mynb=nbwait;
  gainit=0; 
  ninst=0;
  dostop=0;

  startintr();

  while(quitf)
  {
    for(i=0;i<11000;i++)
    {
      if ((pc==bkpt)&&(dostop)) quitf=0;
      else
      {

      exe6809();
    
      for(k=0;k<mynb;k++);
      if (!dostop) dostop++;

      if ((do_irq)&&(!(ccrest&0x10)))
      {
        do_irq=0;
        ccrest|=0x80;
        pshsr(0xff);
        ccrest|=0x10;
        pc=((buf[0xfff8]<<8)+(buf[0xfff9]&255))&0xffff;
      }
      }
      if (!quitf) break;
      
    }
 
    refreshv();


  while(XEventsQueued(display,QueuedAfterFlush))
  {
    XNextEvent(display,&ev);
    switch(ev.type) 
    {
      case Expose: while(XCheckTypedEvent(display,Expose,&ev));
                   refreshsc();
                   break;

      case ButtonPress: switch(ev.xbutton.button)
                        {
                          case 1: pra1|=32; 
                                  buf[0xa7c0]=pra1;
                                  break;
                          default: break;
                     	}
                        break;

      case MotionNotify: crayx=(ev.xbutton.x-20)/2;
                         crayy=(ev.xbutton.y-20)/2;
                         break;

      case ButtonRelease: switch(ev.xbutton.button) 
                          {
                            case 1: pra1&=0xdf;
                                    buf[0xa7c0]=pra1;
                                    break;
                            default: break;
                          }
                          break;
     
      case KeyPress: if ((ev.xkey.keycode&255)==stopkey) quitf=0; else
	             {
                       key=whatkey(ev.xkey.keycode&255);
                       if (key!=0xffff) keyprsd[key]=0;
                     }
                      break;

      case KeyRelease: key=whatkey(ev.xkey.keycode&255);
                       if (key!=0xffff) keyprsd[key]=1;
                       break;
                       
      default: break;
    }
 
  }  
  
  }
  stopintr();

  return ninst;
}
